registerInputEvent("fxDTSBrick", "onPlayerFirstTouch", "Self fxDTSBrick" TAB "Player Player" TAB "Client GameConnection" TAB "MiniGame MiniGame");
registerInputEvent("fxDTSBrick", "onPlayerStopTouch", "Self fxDTSBrick" TAB "Player Player" TAB "Client GameConnection" TAB "MiniGame MiniGame");

if(isFile("Event_onPlayerFirstTouch"))
{
	schedule(0, 0, exec, "Add-Ons/Event_onPlayerFirstAndStopTouch/firstTouchOverwrite.cs");
}

if(isFile("Event_onPlayerStopTouch"))
{
	schedule(0, 0, exec, "Add-Ons/Event_onPlayerFirstAndStopTouch/stopTouchOverwrite.cs");
}

datablock TriggerData(onPlayerFirstAndStopTouchTriggerData)
{
	tickPeriodMS = 150;
};

function onPlayerFirstAndStopTouchTriggerData::onEnterTrigger(%data, %obj, %player)
{
	if(%player.getClassName() !$= "Player")
	{
		return;
	}

	if(!isObejct(%obj.brick))
	{
		return;
	}

	if(!%obj.brick.isColliding())
	{
		return;
	}

	$InputTarget_["Self"] = %obj.brick;
	$InputTarget_["Player"] = %player;
	$InputTarget_["Client"] = %player.client;

	if($Server::LAN)
	{
		$InputTarget_["MiniGame"] = getMiniGameFromObject(%player.client);
	}

	else
	{
		if(getMiniGameFromObject(%obj.brick) == getMiniGameFromObject(%player.client))
		{
			$InputTarget_["MiniGame"] = getMiniGameFromObject(%player);
		}

		else
		{
			$InputTarget_["MiniGame"] = 0;
		}
	}

	%obj.brick.processInputEvent("onPlayerFirstTouch", %player.client);
}

function onPlayerFirstAndStopTouchTriggerData::onLeaveTrigger(%data, %obj, %player)
{
	if(%player.getClassName() !$= "Player")
	{
		return;
	}

	if(!isObject(%obj.brick))
	{
		return;
	}

	if(!%obj.brick.isColliding())
	{
		return;
	}

	$InputTarget_["Self"] = %obj.brick;
	$InputTarget_["Player"] = %player;
	$InputTarget_["Client"] = %player.client;

	if($Server::LAN)
	{
		$InputTarget_["MiniGame"] = getMiniGameFromObject(%player.client);
	}

	else
	{
		if(getMiniGameFromObject(%obj.brick) == getMiniGameFromObject(%player.client))
		{
			$InputTarget_["MiniGame"] = getMiniGameFromObject(%player);
		}

		else
		{
			$InputTarget_["MiniGame"] = 0;
		}
	}

	%obj.brick.processInputEvent("onPlayerStopTouch", %player.client);
}

function fxDTSBrick::createOnPlayerFirstandStopTouchTrigger(%brick)
{
	//credits to Space Guy for showing how to create triggers

	%t = new Trigger()
	{
		datablock = onPlayerFirstAndStopTouchTriggerData;
		polyhedron = "0 0 0 1 0 0 0 -1 0 0 0 1"; //this determines the shape of the trigger
	};

	missionCleanup.add(%t);
	
	%boxMax = getWords(%brick.getWorldBox(), 3, 5);
	%boxMin = getWords(%brick.getWorldBox(), 0, 2);
	%boxDiff = vectorSub(%boxMax, %boxMin);
	%boxDiff = vectorAdd(%boxDiff, "0.2 0.2 0.2"); 
	%t.setScale(%boxDiff);
	%posA = %brick.getWorldBoxCenter();
	%posB = %t.getWorldBoxCenter();
	%posDiff = vectorSub(%posA, %posB);
	%t.setTransform(%posDiff);
	//All this makes a trigger that's slightly bigger than the brick
	//on all sides

	%brick.onPlayerFirstAndStopTouchTrigger = %t;
	%t.brick = %brick;

	return %t;
}

package onPlayerFirstAndStopTouch
{
	function serverCmdAddEvent(%client, %delay, %input, %target, %a, %b, %output, %par1, %par2, %par3, %par4)
	{
		if((%input == inputEvent_GetInputEventIdx("onPlayerFirstTouch") || %input == inputEvent_GetInputEventIdx("onPlayerStopTouch")) && (!isObject(%brick.onPlayerFirstAndStopTouchTrigger)))
		{
			%client.wrenchBrick.createOnPlayerFirstandStopTouchTrigger();
		}

		return parent::serverCmdAddEvent(%client, %delay, %input, %target, %a, %b, %output, %par1, %par2, %par3, %par4);
	}

	function serverCmdClearEvents(%client)
	{
		if(isObject(%client.wrenchBrick.onPlayerFirstAndStopTouchTrigger))
		{
		    %client.wrenchBrick.onPlayerFirstAndStopTouchTrigger.delete();
		}

		parent::serverCmdClearEvents(%client);
	}

	function fxDTSBrick::onDeath(%brick)
	{
		if(isObject(%brick.onPlayerFirstAndStopTouchTrigger))
		{
			%brick.onPlayerFirstAndStopTouchTrigger.delete();
		}

		parent::onDeath(%brick);
	}

	function fxDTSBrick::onRemove(%brick)
	{
		if(isObject(%brick.onPlayerFirstAndStopTouchTrigger))
		{
			%brick.onPlayerFirstAndStopTouchTrigger.delete();
		}

		parent::onRemove(%brick);
	}
};
activatePackage(onPlayerFirstAndStopTouch);